#ifndef DIYA_SHELL_FOREIGN_H
#define DIYA_SHELL_FOREIGN_H
#include "session-shell.h"

#define DIYA_PROP_FOREIGN_WINDOW_APPID "appid"
#define DIYA_PROP_FOREIGN_WINDOW_TITLE "title"
#define DIYA_PROP_FOREIGN_WINDOW_HANDLE "handle"
#define DIYA_PROP_FOREIGN_WINDOW_STATE "state"
#define DIYA_PROP_FOREIGN_WINDOW_PARENT "parent"

enum diya_win_state
{
    DIYA_WIN_STATE_NONE = 0,
    DIYA_WIN_STATE_MINIMIZE = 1 << 0,
    DIYA_WIN_STATE_MAXIMIZE = 1 << 1,
    DIYA_WIN_STATE_FULLSCREEN = 1 << 2,
    DIYA_WIN_STATE_FOCUS = 1 << 3,
};

void diya_session_shell_foreign_toplevel_register(struct wl_registry *registry, uint32_t name, DiyaShell * shell);

DiyaShell* diya_foreign_window_get_shell(DiyaForeignWindow* window);

void diya_foreign_window_set_state(DiyaForeignWindow* window, enum diya_win_state state, bool value);
enum diya_win_state diya_foreign_window_get_state(DiyaForeignWindow* window);
bool diya_foreign_window_is_toplevel(DiyaForeignWindow* window);
DiyaForeignWindow* diya_foreign_window_get_top_level(DiyaForeignWindow* window);
GAppInfo* diya_foreign_window_get_app_info(DiyaForeignWindow* window);
#endif